#!/usr/bin/env Rscript   getwd()
setwd("~/git/LSHTM_analysis/scripts/plotting")
getwd()

#########################################################
# TASK: output barplot by position with each bar coloured by 
# its stability value and active site positions indicated 
# according to colour specified in "subcols_axis_PS.R"
#########################################################

#=======================================================================

############################################################
# 1: Installing and loading required packages and functions
############################################################

#source("~/git/LSHTM_analysis/scripts/Header_TT.R")
library(ggplot2)
library(data.table)
source("../functions/bp_subcolours.R")
source("subcols_axis.R")

# should return the following dfs, directories and variables
# mut_pos_cols
# my_df
# my_df_u
# my_df_u_lig
# dup_muts

cat(paste0("Directories imported:"
           , "\ndatadir:", datadir
           , "\nindir:", indir
           , "\noutdir:", outdir
           , "\nplotdir:", plotdir))

cat(paste0("Variables imported:"
           , "\ndrug:", drug
           , "\ngene:", gene
           , "\ngene_match:", gene_match
           , "\nLength of upos:", length(upos)
           , "\nAngstrom symbol:", angstroms_symbol))

# clear excess variable
rm(dup_muts_cols, mut_pos_cols_lig, my_df_cols, my_df_u_cols_lig, upos)

#=======================================================================
# !!! very important!!!!
#================
# Inspecting mut_pos_cols
# position numbers and colours and assigning axis colours based on lab_fg
# of the correct df
# open file from desktop ("sample_axis_cols") for cross checking
#================
# very important!
#my_axis_colours = mut_pos_cols$lab_fg

if ( nrow(mut_pos_cols) == length(unique(my_df_u_cols$position)) ){
  print("PASS: lengths checked, assigning axis colours")
  my_axis_colours = mut_pos_cols$lab_fg
  cat("length of axis colours:", length(my_axis_colours)
      , "\nwhich corresponds to the number of positions on the x-axis of the plot")
}else{
  print("FAIL:lengths mismatch, could not assign axis colours")
  quit()
}

# further sanity checks
table(mut_pos_cols$lab_bg)
check_lab_bg = sum( table(mut_pos_cols$lab_bg) ) == nrow(mut_pos_cols) # should  be True
check_lab_bg    

table(mut_pos_cols$lab_bg2)
check_lab_bg2 = sum( table(mut_pos_cols$lab_bg2) ) ==  nrow(mut_pos_cols) # should  be True
check_lab_bg2

table(mut_pos_cols$lab_fg)
check_lab_fg = sum( table(mut_pos_cols$lab_fg) ) ==  nrow(mut_pos_cols) # should  be True
check_lab_fg

# sanity checks:
if (check_lab_bg && check_lab_bg2 && check_lab_fg) {
  print("PASS: No. of assigned colours match length")
}else{
  print("FAIL: length of assigned colours mismatch")
  quit()
}

#=======
# output
#=======
# plot name and location
print(paste0("plot will be in:", plotdir))
bp_aa_subcols_duet = "barplot_acoloured_PS.svg"
plot_bp_aa_subcols_duet = paste0(plotdir, "/", bp_aa_subcols_duet)

#=======================================================================
#================
# Data for plots
#================
# REASSIGNMENT as necessary
df  = my_df_u_cols

# sanity checks
str(df)

###########################
# Plot: DUET scores
###########################

#==========================
# Plot 2: Barplot with scores (unordered)
# corresponds to duet_outcome
# Stacked Barplot with colours: duet_outcome @ position coloured by 
# stability scores. This is a barplot where each bar corresponds 
# to a SNP and is coloured by its corresponding DUET stability value.
# Normalised values (range between -1 and 1 ) to aid visualisation
# NOTE: since barplot plots discrete values, colour = score, so number of
# colours will be equal to the no. of unique normalised scores 
# rather than a continuous scale
# will require generating the colour scale separately.
#============================
# sanity checks
upos = unique(df$position)

table(df$duet_outcome)
table(df$duet_outcome)

# add frequency of positions (from lib data.table)
setDT(df)[, pos_count := .N, by = .(position)]

# this is cummulative
table(df$pos_count)

# use group by on this
#library(dplyr)
snpsBYpos_df <- df %>%
  group_by(position) %>%
  summarize(snpsBYpos = mean(pos_count))

table(snpsBYpos_df$snpsBYpos)

snp_count = sort(unique(snpsBYpos_df$snpsBYpos))

# sanity checks
# should be a factor
if (is.factor(df$duet_outcome)){
  print("duet_outcome is factor")
}else{
  print("converting duet_outcome to factor")
  df$duet_outcome = as.factor(df$duet_outcome)
}

is.factor(df$duet_outcome)

table(df$duet_outcome)

# should be -1 and 1
min(df$duet_scaled)
max(df$duet_scaled)

# sanity checks
tapply(df$duet_scaled, df$duet_outcome, min)
tapply(df$duet_scaled, df$duet_outcome, max)

# My colour FUNCTION: based on group and subgroup
# in my case;
# df = df
# group = duet_outcome
# subgroup = normalised score i.e duet_scaled

# check unique values in normalised data
u = unique(df$duet_scaled) 
cat("No. of unique values in normalised data:", length(u))

# Define group
# Create an extra column called group which contains the "gp name and score" 
# so colours can be generated for each unique values in this column
my_grp = df$duet_scaled # no rounding
df$group <- paste0(df$duet_outcome, "_", my_grp, sep = "") 

# Call the function to create the palette based on the group defined above
colours <- ColourPalleteMulti(df, "duet_outcome", "my_grp")
print(paste0("Colour palette generated for: ", length(colours), " colours"))
my_title = "Protein stability (DUET)"
cat("No. of axis colours: ", length(my_axis_colours))

#========================
# plot with axis colours
#========================
class(df$lab_bg)

# define cartesian coord
my_xlim = length(unique(df$position)); my_xlim

# axis label size
my_xals = 18
my_yals = 18

# axes text size
my_xats = 14
my_yats = 18

#******************
# generate plot: with axis colours
#******************
print(paste0("plot name:", plot_bp_aa_subcols_duet))

svg(plot_bp_aa_subcols_duet, width = 26, height = 4)

g = ggplot(df, aes(factor(position, ordered = T)))

# NOTE:  Here it"s important to specify that your axis goes from 1 to max number of levels
# This is the key to generating the geom_tiles OUTside the plotting area on the x-axis!
OutPlot_aa_PS = g + 
  coord_cartesian(xlim = c(1, my_xlim)
                  #, ylim = c(0, 6)0.85
                  , ylim = c(0, max(snp_count))
                  , clip = "off") +
  geom_bar(aes(fill = group), colour = "grey") +
  scale_fill_manual(values = colours
                     , guide = "none") +
  geom_tile(aes(,-0.8, width = 0.95, height = 0.85)
            , fill = df$lab_bg) +
  geom_tile(aes(,-1.2, width = 0.95, height = -0.2)
            , fill = df$lab_bg2) +

  theme(axis.text.x = element_text(size = my_xats
                                    , angle = 90
                                    , hjust = 1
                                    , vjust = 0.4
                                    , colour = my_axis_colours)
         , axis.text.y = element_text(size = my_yats 
                                      , angle = 0
                                      , hjust = 1
                                      , vjust = 0)
         , axis.title.x = element_text(size = my_xals)
         , axis.title.y = element_text(size = my_yals ) 
         , axis.ticks.x = element_blank()) +
  labs(title = ""
       #title = my_title
       , x = "Position"
       , y = "Frequency")

print(OutPlot_aa_PS)
dev.off()

#!!!!!!!!!!!!!!!!
#Warning message:
#  Vectorized input to `element_text()` is not officially supported.
#Results may be unexpected or may change in future versions of ggplot2. 
#!!!!!!!!!!!!!!!!!

# for sanity and good practice
#rm(df)
